package com.connor.jd.plm.handlers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.connor.jd.plm.dialogs.QTXJCDialog;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentProject;
import com.teamcenter.rac.kernel.TCComponentProjectSmartFolder;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.stage.Stage;

public class QTXJCHandler extends AbstractHandler {

	private TCComponent[] com;
	private String type = null;

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		List<String> sfList = new ArrayList<String>();
		String name = arg0.getCommand().getId();
		// System.out.println("name:" + name);
		try {
			AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
			if (app.getTargetComponent() != null && app.getTargetComponent() instanceof TCComponentProject) {
				TCComponentProject project = (TCComponentProject) app.getTargetComponent();
				com = project.getTCProperty("project_data").getReferenceValueArray();
				for (int i = 0; i < com.length; i++) {
					TCComponentProjectSmartFolder sf = (TCComponentProjectSmartFolder) com[i];
					sfList.add(sf.getProperty("object_string"));
				}
				TCSession session = (TCSession) app.getSession();

				switch (name) {
				case "JD2_GTQTXJC":
					type = "GT";
					break;
				case "JD2_BLQTXJC":
					type = "BL";
					break;
				case "JD2_BXQTXJC":
					type = "BX";
					break;
				default:
					break;
				}
				new Thread(() -> {
					new JFXPanel();
					Platform.setImplicitExit(false);
					Platform.runLater(new Runnable() {
						@Override
						public void run() {
							try {
								// System.out.println("type" + type);
								QTXJCDialog qtxjc = new QTXJCDialog(sfList, com, session, type);
								qtxjc.start(new Stage());
							} catch (Exception e) {
								e.printStackTrace();
							}
						}
					});
				}).start();
			} else {
				MessageBox.post("ѡĿ", "ʾ", MessageBox.INFORMATION);
			}
		} catch (TCException e1) {
			e1.printStackTrace();
		}

		return null;
	}

}
