package com.connor.jd.plm.table;

import java.awt.Component;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;

public class MyCellEditor1 extends DefaultCellEditor {
	private int col;
	private int row;
	private JTable table;
	private int top;
	private int end;
	private int bottom;
	private List<Double> data;
	private double low = 0.0;
	private double up = 0.0;
	private int cnt = 0;

	public MyCellEditor1(JTextField paramJTextField) {
		super(paramJTextField);
		// TODO Auto-generated constructor stub
	}

	public MyCellEditor1(JTextField paramJTextField, int top, int end, int bottom) {
		super(paramJTextField);
		// TODO Auto-generated constructor stub
		this.top = top;
		this.end = end;
		this.bottom = bottom;
	}

	public double getLow() {
		return low;
	}

	public void setLow(double low) {
		this.low = low;
	}

	public double getUp() {
		return up;
	}

	public void setUp(double up) {
		this.up = up;
	}

	public int getCnt() {
		return cnt;
	}

	public void setCnt(int cnt) {
		this.cnt = cnt;
	}

	@Override
	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
		this.col = column;
		this.row = row;
		this.table = table;
		bottom = table.getRowCount() - end;
		return super.getTableCellEditorComponent(table, value, isSelected, row, column);
	}

	@Override
	public boolean stopCellEditing() {
		// TODO Auto-generated method stub
		System.out.println("top:" + top + ",end:" + end + ",bottom:" + bottom + "  ¼У" + col);
		data = new ArrayList<Double>();
		Object now = getCellEditorValue();
		Object obj = null;

		if (row == 2) {
			if (now != null && !"".equals(now.toString().trim())) {
				low = Double.parseDouble(now.toString().trim());
				cnt++;
			} else {
				low = 0.0;
				cnt--;
			}
		}
		if (row == 3) {
			if (now != null && !"".equals(now.toString().trim())) {
				up = Double.parseDouble(now.toString().trim());
				cnt++;
			} else {
				up = 0.0;
				cnt--;
			}
		}
		for (int i = top; i < row && i <= bottom; i++) {
			obj = table.getModel().getValueAt(i, col);
			if (obj != null && !"".equals(obj.toString().trim())) {
				data.add(Double.parseDouble(obj.toString().trim()));
			}
		}
		if (row >= top && row <= bottom && now != null && !"".equals(now.toString().trim())) {
			data.add(Double.parseDouble(now.toString().trim()));
		}
		for (int i = row + 1; i <= bottom; i++) {
			obj = table.getModel().getValueAt(i, col);
			if (obj != null && !"".equals(obj.toString().trim())) {
				data.add(Double.parseDouble(obj.toString().trim()));
			}
		}
		System.out.println(Arrays.toString(data.toArray()));

		double sum = 0;
		double max = Double.MIN_VALUE;
		double min = Double.MAX_VALUE;
		for (Double d : data) {
			sum += d;
			max = Math.max(max, d);
			min = Math.min(min, d);
		}
		if (sum != 0) {
			double r = max - min;
			double avg = sum / data.size();
			table.getModel().setValueAt(String.format("%.2f", min), bottom + 1, col);
			table.getModel().setValueAt(String.format("%.2f", max), bottom + 2, col);
			table.getModel().setValueAt(String.format("%.2f", r), bottom + 3, col);
			table.getModel().setValueAt(String.format("%.2f", avg), bottom + 5, col);
			if (data.size() - 1 > 0) {
				double stdevSum = 0;
				for (Double d : data) {
					stdevSum += Math.pow(d - avg, 2);
				}
				double stdev = Math.sqrt(stdevSum / (data.size() - 1));
				double bar1 = avg - 3 * stdev;
				double bar2 = avg + 3 * stdev;
				table.getModel().setValueAt(String.format("%.2f", stdev), bottom + 4, col);
				table.getModel().setValueAt(String.format("%.2f", bar1), bottom + 6, col);
				table.getModel().setValueAt(String.format("%.2f", bar2), bottom + 7, col);

				double cp = 0.0;
				if (cnt == 0) {
					table.getModel().setValueAt("", bottom + 8, col);
				} else if (cnt == 2) {
					cp = (up - low) / (6 * stdev);
					table.getModel().setValueAt(String.format("%.2f", cp), bottom + 8, col);
				} else if (doubleIsEqual(up, 0.0)) {
					cp = (avg - low) / (3 * stdev);
					table.getModel().setValueAt(String.format("%.2f", cp), bottom + 8, col);
				} else {
					cp = (up - avg) / (3 * stdev);
					table.getModel().setValueAt(String.format("%.2f", cp), bottom + 8, col);
				}
				double cpu = 0.0;
				if (doubleIsEqual(up, 0.0)) {
					table.getModel().setValueAt("", bottom + 9, col);
				} else {
					cpu = (up - avg) / (3 * stdev);
					table.getModel().setValueAt(String.format("%.2f", cpu), bottom + 9, col);
				}
				double cpl = 0.0;
				if (doubleIsEqual(low, 0.0)) {
					table.getModel().setValueAt("", bottom + 10, col);
				} else {
					cpl = (avg - low) / (3 * stdev);
					table.getModel().setValueAt(String.format("%.2f", cpl), bottom + 10, col);
				}
				double cpk = 0.0;
				if (cnt == 2) {
					cpk = (1 - 2 * Math.abs(((low + up) / 2 - avg)) / (up - low)) * cp;
					table.getModel().setValueAt(String.format("%.2f", cpk), bottom + 11, col);
				} else {
					cpk = cp;
					table.getModel().setValueAt(doubleIsEqual(cpk, 0.0) ? "" : String.format("%.2f", cpk), bottom + 11,
							col);
				}
				double su = 0.0;
				if (doubleIsEqual(cpu, 0.0)) {
					table.getModel().setValueAt("", bottom + 12, col);
				} else {
					su = (1 - normSDist(cpu * 3)) * 1000000;
					table.getModel().setValueAt(String.format("%.2f", su), bottom + 12, col);
				}
				double sl = 0.0;
				if (doubleIsEqual(cpl, 0.0)) {
					table.getModel().setValueAt("", bottom + 13, col);
				} else {
					sl = (1 - normSDist(cpl * 3)) * 1000000;
					table.getModel().setValueAt(String.format("%.2f", sl), bottom + 13, col);
				}
				if (cnt == 0) {
					table.getModel().setValueAt("", bottom + 14, col);
				} else {
					table.getModel().setValueAt(String.format("%.2f", su + sl), bottom + 14, col);
				}
				if (cnt == 0) {
					table.getModel().setValueAt("", bottom + 15, col);
				} else if (cpk > 1.99) {
					table.getModel().setValueAt("ǳ", bottom + 15, col);
				} else if (cpk > 1.66) {
					table.getModel().setValueAt("ܺ", bottom + 15, col);
				} else if (cpk > 1.32) {
					table.getModel().setValueAt("", bottom + 15, col);
				} else if (cpk > 0.99) {
					table.getModel().setValueAt("", bottom + 15, col);
				} else {
					table.getModel().setValueAt("", bottom + 15, col);
				}
				System.out.println("cp:" + cp + ",cpu:" + cpu + ",cpl:" + cpl + ",cpk:" + cpk + ",su:" + su + ",sl:"
						+ sl + ",ppm:" + (su + sl));
			} else {
				table.getModel().setValueAt("", bottom + 4, col);
				table.getModel().setValueAt("", bottom + 6, col);
				table.getModel().setValueAt("", bottom + 7, col);
				table.getModel().setValueAt("", bottom + 8, col);
				table.getModel().setValueAt("", bottom + 9, col);
				table.getModel().setValueAt("", bottom + 10, col);
				table.getModel().setValueAt("", bottom + 11, col);
				table.getModel().setValueAt("", bottom + 12, col);
				table.getModel().setValueAt("", bottom + 13, col);
				table.getModel().setValueAt("", bottom + 14, col);
				table.getModel().setValueAt("", bottom + 15, col);
			}
		} else {
			table.getModel().setValueAt("", bottom + 1, col);
			table.getModel().setValueAt("", bottom + 2, col);
			table.getModel().setValueAt("", bottom + 3, col);
			table.getModel().setValueAt("", bottom + 5, col);
			table.getModel().setValueAt("", bottom + 4, col);
			table.getModel().setValueAt("", bottom + 6, col);
			table.getModel().setValueAt("", bottom + 7, col);
			table.getModel().setValueAt("", bottom + 8, col);
			table.getModel().setValueAt("", bottom + 9, col);
			table.getModel().setValueAt("", bottom + 10, col);
			table.getModel().setValueAt("", bottom + 11, col);
			table.getModel().setValueAt("", bottom + 12, col);
			table.getModel().setValueAt("", bottom + 13, col);
			table.getModel().setValueAt("", bottom + 14, col);
			table.getModel().setValueAt("", bottom + 15, col);
		}
		return super.stopCellEditing();
	}

	private boolean doubleIsEqual(double a, double b) {
		return Math.abs(a - b) < 0.000001;
	}

	private double normSDist(double z) {
		// this guards against overflow
		if (z > 6)
			return 1;
		if (z < -6)
			return 0;

		double gamma = 0.231641900, a1 = 0.319381530, a2 = -0.356563782, a3 = 1.781477973, a4 = -1.821255978,
				a5 = 1.330274429;

		double x = Math.abs(z);
		double t = 1 / (1 + gamma * x);

		double n = 1 - (1 / (Math.sqrt(2 * Math.PI)) * Math.exp(-z * z / 2))
				* (a1 * t + a2 * Math.pow(t, 2) + a3 * Math.pow(t, 3) + a4 * Math.pow(t, 4) + a5 * Math.pow(t, 5));
		if (z < 0)
			return 1.0 - n;

		return n;
	}

}
